//Gerüst für Lyapunov-Fraktal 03
//Mit Tasten <1>...<6> wählt man das gewünschte Bild
//1: Chaos:  Rot (fest)  //Ordnung: Cyan linear - gespreizt, seltene Lambda-Werte abgeschnitten 
//2: Chaos: Blau (fest) //Ordnung: rot-gelb linear gespreizt, seltene Lambda-Werte abgeschnitten     
//3: Chaos: Blau (fest) //Ordnung: schwarz-weiß, linear gespreizt, seltene Lambda-Werte abgeschnitten 
//4: Chaos: Gelb (fest) //Ordnung: bunt - es werden keine Werte werden abgeschnitten
//5: Chaos: Differenzierung nach Größe des positiven Lambda    //Ordnung: schwarz-weiß, linear gespreizt, seltene Lambda-Werte abgeschnitten  
//7: Chaos: rot (linear) //Ordnung blau-Töne "demokratisch" - alle Lambda-Werte werden benutzt 
//Achtung! Nummer 6 und Nummer 7 funktionieren erst, wenn bereits 1,2,...oder 5 gelaufen ist!!
//Linksklick zoomen an angeklickte Stelle
//Rechtsklick kann man notfalls verwenden, um den Fokus auf die Anwendung zu setzen.
//Linksklick zoomen an angeklickte Stelle
//Rechtsklick kann man notfalls verwenden, um den Fokus auf die Anwendung zu setzen.
//Taste <a> wählt eine neue Reihenfolge von A und B
//Taste <c> wählt einen zufälligen c-Wert
//Taste <s> speichert das Bild im Programmordner
//
//Mit den Tasten <l>,<r>,<u> uns <o> kann man das Bild verschieben
//Weitere Informationen:  https://ningelgen.eu
/////////////////////////////////////////////////////////////////////////////////////////////////////////
private ArrayList<Threads> threads;
private FarbTafelTrap farben;
private FarbTafel1024 farben1024;
private FarbTafel8192 farben8192;
private Table table;
private char reihenFolge[] ={'A','A','A','B','B','B','A','A','A','B','B','B'};
private int laenge= reihenFolge.length;
private double xU = 2; 
private double yU = 2; 
private double xO = 3;
private double yO = 3;
private double zoomFaktor=1;
private double wh = xO-xU;
private double xStart;
private int Selektor;
private int[][] werte;
private int[] werteSumme;
private int[] werteSumme1040;
private int[] anzahlGW;
private int[] anzahlLP;//Anzahl positiver Lambda je Thread
private int gesamtAnzahlLP =0;//Gesamtanzahl positiver Lambda
private int maxiterations = 2000;//Iterationsgrenze 
private int massFuerUnendlich = 100000;
private int nummerThread;
private int anzahlThreads = Runtime.getRuntime().availableProcessors(); //für die Farbverteilung nur ein Thread!
private boolean tabelleErzeugen;
private int[] grauBereich256;
private int[] grauBereich1024;
private int fensterBreite=800;

void settings(){
  size(fensterBreite,fensterBreite);
}

void setup() {
  background(255); 
  colorMode(RGB);
  threads = new  ArrayList<Threads>();   
  table = new Table();
  table.addColumn("Nummer");
  table.addColumn("Anzahl");
  table.addColumn("Anzahl2");
  grauBereich256= new int[256];
  for(int i =0; i<256;i++) grauBereich256[i] =0;
  grauBereich1024= new int[1024];
  for(int i =0; i<1024;i++) grauBereich1024[i] =0;
  xStart=0.5;
  farben= new FarbTafelTrap();
  farben.farbTafelTrapErzeugen();
  farben1024 = new FarbTafel1024();
  farben1024.farbTafel1024Erzeugen();
  farben8192 = new FarbTafel8192();
  farben8192.farbTafel8192Erzeugen();
  Selektor = 5;
  tabelleErzeugen = false;
  starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread, xStart,Selektor, reihenFolge, grauBereich256, grauBereich1024); 
                
}

/////////////////////////////////////////////////////////////////
void starteThreads(double px, double py, int pmaxiterations, int pUnendlich, double pwh, int nummer, double X0, 
                   int selektor, char[] pReihenFolge , int[] pGrauBereich256, int[] pGrauBereich1024){
  
  xU = px; yU = py;
  xStart = X0; 
  reihenFolge = pReihenFolge;
  nummerThread = nummer;
  maxiterations = pmaxiterations;
  massFuerUnendlich = pUnendlich;
  Selektor = selektor;
  grauBereich256  = pGrauBereich256;
  grauBereich1024 = pGrauBereich1024;
  wh = pwh;    
  werte = new int[anzahlThreads][99840];
  werteSumme = new int[99840]; 
  werteSumme1040 = new int[1050];
  anzahlGW = new int[99840]; 
  anzahlLP = new int[anzahlThreads];
  
  

  double  y= yO-wh/anzahlThreads;
  while(nummerThread <anzahlThreads){
        Threads t = new Threads(xU,y,maxiterations,massFuerUnendlich,wh/anzahlThreads, nummerThread,xStart,
                        Selektor, reihenFolge,  grauBereich256, grauBereich1024);
        threads.add(t);
        t.start(); 
        nummerThread++;
        y=y-wh/anzahlThreads;
        delay(200);//zur Verringerung der Pixelfehler 
  }  
}
//////////////////////////////////////////////////////////////
void draw() {
 
  for(Threads t: threads){
      while (t.running){       
            try{
            Thread.sleep(10);  
            }catch (Exception e) {  }  ;                
       }
       if(t.gibNummer() ==0){
         println("fertig!");
       }
       for(int i=0; i< anzahlThreads;i++){
         if(t.gibNummer() ==i){
           werte[i] =t.gibWerteThread(i);// print(i,werte[i][0],werte[i][1]+" ");
           anzahlLP[i] = t.gibAnzahlLPThread(i);//println(i,anzahlLP[i]);           
         }  
       }
       noLoop();
  } 
  
  for (int i=0; i<threads.size(); i++){
    image(threads.get(i).pg,0,i*height/anzahlThreads);  
  }  
  
}


///////////////////////////////////////////////////////////////////
void mousePressed() { 
     nummerThread =0;
     threads = new  ArrayList<Threads>(); 
     double xUNeu, xONeu, yUNeu, yONeu;//Temp. Speicher
         
      if (mouseButton == LEFT){ //Angeklickte Stelle zoomen
          xUNeu = map(mouseX,0,width,(float)xU,(float)xO)-(xO-xU)/10;
          xONeu = map(mouseX,0,width,(float)xU,(float)xO)+(xO-xU)/10; 
          xU = xUNeu; xO = xONeu; 
          yUNeu = map(mouseY,height,0,(float)yU,(float)yO)-(yO-yU)/10;
          yONeu = map(mouseY,height,0,(float)yU,(float)yO)+(yO-yU)/10; 
          yU =yUNeu; yO = yONeu; 
          wh = wh/5;
          zoomFaktor =zoomFaktor*5;
          println("Zoomfaktor: "+zoomFaktor);
          starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,xStart,Selektor,reihenFolge, grauBereich256, grauBereich1024);  
          redraw();   
          println("xU = "+ xU + " "+" yU = " + yU+ " "+" xO = "+xO+" yO = "+yO);
     }
    
  
}
/////////////////////////////////////////////////////////////////
void keyPressed() {
  
  if (key == 'a'){ 
      print("Neue Reihenfolge: ");
      for(int i = 0; i<laenge;i++){
        float z= random(1);
        if(z<0.5) reihenFolge[i] = 'B';
        else reihenFolge[i] = 'A';
        print(reihenFolge[i]+" ");
      }
       xU = 2; 
       yU = 2; 
       xO = 3;
       yO = 3;
       wh = 1;
       nummerThread =0;
       tabelleErzeugen = false;
       threads = new  ArrayList<Threads>(); 
       starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,xStart,Selektor,reihenFolge, grauBereich256, grauBereich1024);                   
       redraw();  
  }
  
  
  if (key == '1'){//Chaos:  schwarz -> rot linear - Ordnung: Cyan linear - gespreizt, seltene Lambda-Werte abgeschnitten                
      farben.farbTafelTrapErzeugen();
      nummerThread =0;
      tabelleErzeugen = false;
      farben.farbTafelTrapErzeugen();
      farben1024.farbTafel1024Erzeugen();
      farben8192.farbTafel8192Erzeugen();
      println("Chaos: schwarz -> rot linear  - Ordnung: Cyan linear - gespreizt, seltene Lambda-Werte abgeschnitten    ");
      Selektor = 1;  
      nummerThread =0;
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,xStart,Selektor,reihenFolge, grauBereich256, grauBereich1024);                   
      redraw();
  }   
  
  if (key == '2'){//Chaos: schwarz -> blau linear  - Ordnung: rot -> gelb linear gespreizt, seltene Lambda-Werte abgeschnitten      
      farben1024.farbTafel1024Erzeugen();
      nummerThread =0;
      tabelleErzeugen = false;
      farben.farbTafelTrapErzeugen();
      farben1024.farbTafel1024Erzeugen();
      farben8192.farbTafel8192Erzeugen();
      println("Chaos: schwarz -> blau linear- Ordnung: rot-gelb linear gespreizt, seltene Lambda-Werte abgeschnitten");
      Selektor = 2;     
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,xStart,Selektor ,reihenFolge, grauBereich256, grauBereich1024);
      redraw();
  }  
  
  if (key == '3'){ //Chaos: schwarz -> blau linear - Ordnung: schwarz-weiß, linear gespreizt, seltene Lambda-Werte abgeschnitten 
      nummerThread =0;
      tabelleErzeugen = false;
      farben.farbTafelTrapErzeugen();
      farben1024.farbTafel1024Erzeugen();
      farben8192.farbTafel8192Erzeugen();
      println("Chaos:schwarz -> blau linear  - Ordnung: schwarz-weiß, linear gespreizt, seltene Lambda-Werte abgeschnitten ");
      Selektor = 3;     
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,xStart,Selektor,reihenFolge, grauBereich256, grauBereich1024);
      redraw();
  }  
   
  if (key == '4'){ //Chaos: schwarz -> grün linear  - Ordnung: Differenzierung nach Größe des negativen Lambda in blau- und rot-Tönen
                   //- es werden keine Werte werden abgeschnitten
      nummerThread =0;
      tabelleErzeugen = false;     
      farben.farbTafelTrapErzeugen();
      farben1024.farbTafel1024Erzeugen();
      farben8192.farbTafel8192Erzeugen();
      println("Neue Farbpalette erzeugt! ");
      println("Chaos: schwarz -> grün linear  - Ordnung: Differenzierung nach Größe des negativen Lambda in blau- und rot-Tönen");
      Selektor = 4;
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,xStart,Selektor,reihenFolge, grauBereich256, grauBereich1024);
      redraw();
  }  

  if (key == '5'){//Chaos: Differenzierung nach Größe des positiven Lambda (bunt)   //Ordnung: schwarz-weiß, linear gespreizt, seltene Lambda-Werte abgeschnitten    
      nummerThread =0;
      tabelleErzeugen = false;
      farben.farbTafelTrapErzeugen();
      farben1024.farbTafel1024Erzeugen();
      farben8192.farbTafel8192Erzeugen();
      Selektor = 5;
      println("Chaos: Differenzierung nach Größe des positiven Lambda (bunt)- Ordnung: schwarz-weiß, linear gespreizt, seltene Lambda-Werte abgeschnitten    ");
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,xStart,Selektor,reihenFolge, grauBereich256, grauBereich1024);
      redraw();
  } 
  
  if (key == '6'){//Chaos:  schwarz - linear - Ordnung grau "demokratisch" - alle Lambda-Werte werden benutzt         
       nummerThread =0;
       Selektor =6;
       farben.farbTafelTrapErzeugen();
       farben1024.farbTafel1024Erzeugen();
       farben8192.farbTafel8192Erzeugen();
       println("Chaos: schwarz -> blau linear - Ordnung: grau 'demokratisch' - alle Lambda-Werte werden benutzt    ");
       for(int i=0; i<99840;i++){//Initialisierung
         werteSumme[i] =0;
         anzahlGW[i] = 0;
         if(i<1040)werteSumme1040[i]=0;
       }
            
       for(int i=1; i<99840;i++){ //Berechnung der Anzahl aller Treffer bei i über alle Threads bei negativem Lambda
         for(int j=0; j<anzahlThreads;j++){ //bei einer Spreizung bis 99840
            werteSumme[i] = werteSumme[i] + werte[j][i];           
         }
       } 
       //Um ein Übersichtsschaubild zeichnen zu können, Spreizung nur bis 1040
       int j =0;////Berechnung der Anzahl aller Treffer bei i über alle Threads bei negativem Lambda
       for(int i=0; i<99840;i++){//bei einer Spreizung bis 1040
         if(i%96!=0){
         werteSumme1040[j] = werteSumme1040[j]+werteSumme[i];
         }else{
           j++;
           werteSumme1040[j] = werteSumme1040[j]+werteSumme[i];
         }
       }
       
       gesamtAnzahlLP =0;
       for(int i=0; i<anzahlThreads;i++){//Berechnung der Anzahl aller Treffer bei i über alle Threads bei positivem Lambda
         gesamtAnzahlLP = gesamtAnzahlLP + anzahlLP[i];
       }
      
      //Kontrolle : Ausgabe in ein cvs-Dokument
      for(int i=0; i<99840; i++){
           TableRow newRow = table.addRow();
           newRow.setInt("Nummer", i);
           newRow.setInt("Anzahl",werteSumme[i] );    
           if(i<1040) newRow.setInt("Anzahl2",werteSumme1040[i]);
      }//Kontrolle   
      saveTable(table, "anzahl.csv");
      
      //anzahl der Werte pro Grauwert zB bei fensterBreite 400 und gesamtAnzahlLP (Lambda positiv) = 80000 => breite =312
      int breite256 = (fensterBreite*fensterBreite - gesamtAnzahlLP) /256;                                                              
      int k =0;                                                        
      int teilSumme =0;
      
      for(int i=0; i<256;i++){
        while(teilSumme<=breite256 && k<99839 ){
          teilSumme = teilSumme+werteSumme[k];
          k++;
        }
        grauBereich256[i]=k-1;//print(i,k-1,"  ");//wichtige Kontrolle!
        teilSumme =0;
      }
      
      threads = new  ArrayList<Threads>(); //grauBereich1024 ist zwar definiert, hat aber hier keine Bedeutung
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,xStart,Selektor,reihenFolge, grauBereich256, grauBereich1024);
      redraw();
  }  
  
  if (key == '7'){//Chaos:  schwarz -> rot linear - Ordnung Blautöne "demokratisch" - alle Lambda-Werte werden benutzt         
       nummerThread =0;
       Selektor =7;
       farben.farbTafelTrapErzeugen();
       farben1024.farbTafel1024Erzeugen();
       farben8192.farbTafel8192Erzeugen();
       println("Chaos: schwarz -> rot linear - Ordnung: blau-Töne 'demokratisch' - alle Lambda-Werte werden benutzt    ");
       for(int i=0; i<99840;i++){//Initialisierung
         werteSumme[i] =0;
         anzahlGW[i] = 0;
         if(i<1040)werteSumme1040[i]=0;
       }
            
       for(int i=1; i<99840;i++){ //Berechnung der Anzahl aller Treffer bei i über alle Threads bei negativem Lambda
         for(int j=0; j<anzahlThreads;j++){ //bei einer Spreizung bis 99840
            werteSumme[i] = werteSumme[i] + werte[j][i];           
         }
       } 
       //Um ein Übersichtsschaubild zeichnen zu können, Spreizung nur bis 1040
       int j =0;////Berechnung der Anzahl aller Treffer bei i über alle Threads bei negativem Lambda
       for(int i=0; i<99840;i++){//bei einer Spreizung bis 1040
         if(i%96!=0){
         werteSumme1040[j] = werteSumme1040[j]+werteSumme[i];
         }else{
           j++;
           werteSumme1040[j] = werteSumme1040[j]+werteSumme[i];
         }
       }
       
       gesamtAnzahlLP =0;
       for(int i=0; i<anzahlThreads;i++){//Berechnung der Anzahl aller Treffer bei i über alle Threads bei positivem Lambda
         gesamtAnzahlLP = gesamtAnzahlLP + anzahlLP[i];
       }
    
      //Kontrolle : Ausgabe in ein cvs-Dokument
      for(int i=0; i<99840; i++){
           TableRow newRow = table.addRow();
           newRow.setInt("Nummer", i);
           newRow.setInt("Anzahl",werteSumme[i] );    
           if(i<1040) newRow.setInt("Anzahl2",werteSumme1040[i]);
      }//Kontrolle   
      saveTable(table, "anzahl.csv");
      
      
      //anzahl der Werte pro Grauwert zB bei fensterBreite 400 und gesamtAnzahlLP (Lambda positiv) = 80000 => breite =78
      int breite1024 =(fensterBreite*fensterBreite - gesamtAnzahlLP) /1024;                                                                 
      int k =0;                                                        
      int teilSumme =0;
      
       for(int i=0; i<1024;i++){
        while(teilSumme<=breite1024 && k<99839 ){
          teilSumme = teilSumme+werteSumme[k];
          k++;
        }
        grauBereich1024[i]=k-1;//print(i,k-1,"  ");//wichtige Kontrolle!
        teilSumme =0;
      }
      
      threads = new  ArrayList<Threads>(); //grauBereich256 ist zwar definiert, hat aber hier keine Bedeutung
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,xStart,Selektor,reihenFolge, grauBereich256, grauBereich1024);
      redraw();
  }  
    
  if (key == '+'){//Iterationsgrenze erhöhen
     nummerThread =0;
     tabelleErzeugen = false;
     maxiterations *= 2; println("Iterationsgrenze: "+maxiterations);
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,xStart,Selektor,reihenFolge, grauBereich256, grauBereich1024);
  }
  if (key == '-') {//Iterationsgrenze veringern
      nummerThread =0;
      tabelleErzeugen = false;
      maxiterations /= 2;println("Iterationsgrenze: "+maxiterations);
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,xStart,Selektor,reihenFolge, grauBereich256, grauBereich1024);
  }
//Die folgenden Aktionen betreffen zoomen und verschieben des Bildes//////////////////////////////// 
  if (key == 'z'){//zoomen in der Mitte
     double xUNeu, xONeu, yUNeu, yONeu;//Temp. Speicher
     nummerThread =0;
     tabelleErzeugen = false;
     xUNeu = xU+0.25*(xO-xU);yUNeu = yU+0.25*(yO-yU);
     xONeu = xO-0.25*(xO-xU);yONeu = yO-0.25*(yO-yU);
     xU = xUNeu;xO = xONeu; 
     yU =yUNeu; yO = yONeu; 
     wh=wh/2;
     zoomFaktor =zoomFaktor*2;
     println("Zoomfaktor: "+zoomFaktor);
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,xStart,Selektor,reihenFolge, grauBereich256, grauBereich1024);
  }
  if (key == 'l'){//Bild nach links verschieben
     nummerThread =0;
     tabelleErzeugen = false;
     xO = xO + wh/10;
     xU = xU + wh/10;
     println("Verschiebung nach Links");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,xStart,Selektor,reihenFolge, grauBereich256, grauBereich1024);
  }
  if (key == 'r'){//Bild nach rechts verschieben
     nummerThread =0;
     tabelleErzeugen = false;
     xO = xO - wh/10;
     xU = xU - wh/10;
     println("Verschiebung nach Rechts");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,xStart,Selektor,reihenFolge, grauBereich256, grauBereich1024);
  }
   if (key == 'u'){//Bild nach unten verschieben
     nummerThread =0;
     tabelleErzeugen = false;
     yO = yO + wh/10;
     yU = yU + wh/10;
     println("Verschiebung nach unten");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,xStart,Selektor,reihenFolge, grauBereich256, grauBereich1024);
  }
  if (key == 'o'){//bild nach oben verschieben
     nummerThread =0;
     tabelleErzeugen = false;
     yO = yO - wh/10;
     yU = yU - wh/10;
     println("Verschiebung nach oben");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,xStart,Selektor,reihenFolge, grauBereich256, grauBereich1024);
  }
  ///Bild speichern/////////////////////////////////////////////////////////////////////////
  if (key == 's') {saveFrame("LyapunovFraktal###.png");println("Bild gespeichert");}
  redraw();
}
