//class MyThread extends Threads...
//////////////////////////////////////////////////////////////////////////
class Threads extends Thread {
  private  char[] reihenFolge;
  private   color farbe;
  private   PGraphics pg;
  private   int maxiterations;  
  private   int tN;
  private   int selektor;
  private   int massFuerUnendlich;
  private   double xmin, ymin;  
  private   double wh;
  protected boolean running = false;  
  private   double xStart;
  private   double r;
  private   double lambdaI=0;
  private   double LambdaResult =0;
  private   double LambdaResultN =0;//für negative Lambda
  private   double LambdaResultP =0;//für positive Lambda
  private   double parameter = 1.8;
  private   int index;
  private   int gWert;
  private   int[][] anzahl;
  private   int[] GrauBereich256;
  private   int[] GrauBereich1024;
  private   int[] anzahlLP ;//Anzahl der Pixel mit Lambda >=0
  private   int j;
  private   int startAb = 1000;
  private   int LNFaktor = -43000;//Faktor zur Streckung der negativen Lambda auf 99840 -Muss angepasst werden
  private   int LPFaktor = 23000;//Faktor zur Streckung der Lambda >= 0 auf 1024 -Muss angepasst werden
  private   boolean undefiniert = false;//Lambda kleiner als untere negative Schranke (z.B. -10 000)
  private   int anzahlThreads = Runtime.getRuntime().availableProcessors(); //für die Farbverteilung nur ein Thread!
  
  //-----------------------------------------
  // Thread anlegen und Parameter übergeben
  //-----------------------------------------
  
  public Threads(double px0, double py0, int pmaxiterations, int pmUnendlich, double pwh, 
                 int nummer, double X0, int Selektor, char[] pReihenFolge,  int[] pGrauBereich256,int[] pGrauBereich1024) {
    // benötigte Parameter
    //grauWerte = pGrauWerte;
    reihenFolge = pReihenFolge;
    anzahl = new int[anzahlThreads][99840];
    anzahlLP = new int[anzahlThreads];
    selektor = Selektor;
    tN = nummer; 
    GrauBereich256 = pGrauBereich256;
    GrauBereich1024 = pGrauBereich1024;
    wh = pwh;
    xmin=px0; ymin=py0; 
    xStart = X0; 
    maxiterations = pmaxiterations;
    massFuerUnendlich = pmUnendlich; 
    colorMode(HSB,256,256,256);
    for(j=0;j<anzahlThreads;j++){
      anzahlLP[j]=0;
      for(int i =0; i<99840;i++){
        anzahl[j][i] = 0;
      }
    }
        
    pg = createGraphics(width,height/anzahlThreads);
         
  }
 ////////////////////////////////////////////////////////////////////  
 public int gibNummer(){   
    return tN;   
  }
 ///////////////////////////////////////////////////////////////
 public int[] gibWerteThread(int i){  
    return anzahl[i];  
 }
 //////////////////////////////////////////////////////////////
 public int gibAnzahlLPThread(int i){
    return anzahlLP[i];
 }
 //////////////////////////////////////////////////////////////////
 public void run() {
    
 bild();

} 
////////////////////////////////////////////////////////////////////////////////////
 void bild(){
  tN =this.gibNummer();
  
    this.running = true;
    pg.beginDraw();
      pg.loadPixels();
                       
        // x wird von xmin nach ixmax iteriert
        double xmax = xmin + anzahlThreads*wh;
        double ymax = ymin + wh;
            
        // die inkrimentelle Erhoehung für x und y
        double dx = (xmax - xmin) / (pg.width);
        double dy = (ymax - ymin) / (pg.height);
        double y = ymin;
        for (int j =pg.height-1; j >= 0; j--) { 
          double x = xmin; 
          for (int i = 0; i < pg.width; i++) {
             LambdaResult = lyapunov(x,y);//if(LambdaResultN >=0 && tN==1)print(LambdaResultN+" ");
             farbe = faerben(LambdaResult);   
             pg.pixels[i+j*pg.width] = farbe;
             //-------------------------------------------------------------------------------------
             //Wird benötigt, um Grauwert-Tabelle zu erstellen ("Demokratische" Verteilung)
             //Streckung LambdaResultNN auf 99840
             if(LambdaResult<0){
               LambdaResultN = LNFaktor*LambdaResult; //Nur negative LambdaResultN!   
               if(LambdaResultN > 99839) LambdaResultN = 99839;
               index = (int)LambdaResultN; 
               anzahl[tN][index] = anzahl[tN][index]+1;
             }else{ //LambdaResult >=0
               anzahlLP[tN] = anzahlLP[tN]+1;//Werte >= 0 werden hier gezählt
               LambdaResultP = LPFaktor*LambdaResult;//if(tN==8 && LambdaResultP >1000)print(LambdaResultP+" ");
               if(LambdaResultP > 1023) LambdaResultP= 1023;
             }
             //Nur zum testen des Bereichs von LambdaResultN
             /*if(tN==4 && LambdaResultN>LambdaMax){
               LambdaMax=LambdaResultN;
               print(LambdaMax+"   ");              
             } */                                    
             
             //----------------------------------------------------------------------------------
            x += dx; 
          }
          y += dy;
        }        
    pg.updatePixels();     
    pg.endDraw();   
    this.running = false;  
 }
////////////////////////////////////////////////////////////////////
double lyapunov(double R1, double R2){
   int stopp=0;
   boolean gestoppt =false;
   double x = xStart;//Startwert
   double lambda =0;
   undefiniert = false;
   for(int i =0; i<maxiterations;i++){
     
       if(reihenFolge[i % reihenFolge.length] == 'A') r = R2;           
       else r=R1;
       //if(tN==8) print((x+r)% PI+" ");
       if((x+r)% PI < PI/2) 
       x = parameter*Math.sin(x+r)*Math.sin(x+r);//
       else x= parameter*Math.sin(x+r)*Math.sin(x+r)+1.5*r*r;
       if(x<-100000){
         stopp = i; 
         gestoppt = true;
         undefiniert = true;
         break;
       }
       lambdaI =  Math.log(Math.abs(2*parameter*Math.sin(x+r)*Math.cos(x+r))); //if(tN==8 && i > maxiterations-3)print(lambdaI+" ");//kann Infinity werden
       if(i>=startAb) lambda = lambda + lambdaI;  //if(tN==8 && i > maxiterations-3) print(lambdaI+" ");    
      } 
      if(gestoppt){
         lambda = lambda/(float(stopp)-startAb);   
      }
      else lambda = lambda/(float(maxiterations)-startAb);   
      //if(lambda > 0.6) print(lambda+" ");//falls lambda positiv lambda < 0.
      //if(tN==8) print(lambda+" ");    
      return lambda;
  }
//////////////////////////////////////////////////////////////////
 color faerben(double Lambda){
       
    switch(selektor){
      
    case 1: 
       if(Lambda >= 0 ){ //Chaos: schwarz -> rot linear 
          //colorMode(RGB);farbe = color(255,0,0);
          //Alternative, die die Größe von Lambda berücksichtigt
          Lambda = 3000*Lambda;   
          index = (int)(Lambda);
          if(index>1023) index =1023;
          farbe = farben.farbenTrapRot1024[1023-index];              
       }else{ //Ordnung: Cyan linear - gespreizt, seltene Lambda-Werte abgeschnitten                 
         Lambda = -2000*Lambda;             
          if(Lambda>1023) Lambda=1023;//Endfarbe des Verlaufs            
          index =round((float)Lambda);
          farbe = farben.farbenTrapCyan1024[index];        
       }         
      if(undefiniert) farbe = color(0,0,255);//blau: Endfarbe Lambda negativ
      break;  
      
     case 2: 
      if(Lambda >= 0 ){ //Chaos: schwarz -> blau linear 
         // colorMode(RGB);farbe = color(0,0,255);
          Lambda = 3000*Lambda;   
          index = (int)(Lambda);
          if(index>1023) index =1023;
          farbe = farben.farbenTrapBlau1024[1023-index];          
       }else{  //Ordnung: rot-gelb linear gespreizt, seltene Lambda-Werte abgeschnitten                 
           Lambda = -1800*Lambda;   //if(Lambda >300)print(Lambda+" ");            
           if(Lambda>1023) Lambda=1023;//Endfarbe des Verlaufs                      
           index =round((float)Lambda);//Es werden hier nur die Indizes von 0 bis ca. 317 verwendet
           farbe =  farben1024.farben1024Fest16RotGelb[1023-index];  
      } 
      if(undefiniert) { colorMode(RGB);farbe = color(0,0,255);}//blau: Endfarbe
      break;   
      
      
     case 3: 
      if(Lambda >= 0 ){ //Chaos: schwarz -> grün linear 
         //colorMode(RGB);farbe = color(0,0,255);
          Lambda = 3000*Lambda;   
          index = (int)(Lambda); //if(tN==4)print(index+" ");
          if(index>1023) index =1023; 
          farbe = farben.farbenTrapGruen1024[1023-index];  //if(tN==4)print(blue(farbe)+" ");  
      }else{ //Ordnung: schwarz-weiß, linear gespreizt, seltene Lambda-Werte abgeschnitten 
           Lambda = -300*Lambda;             
           if(Lambda>255) Lambda=255;//Endfarbe des Verlaufs - höhere Werte werden "abgeschnitten"   
           index =(int)Lambda;    //Konsequenz: dunkle Werte werden "gestreckt"                  
           farbe =  color(255-index);             
      } 
      if(undefiniert) { colorMode(RGB);farbe = color(0,255,0);}//grün
      break;
      
      
    case 4: 
      if(Lambda >= 0 ){  //Chaos: weiß blau schwarz linear
          //colorMode(RGB);farbe = color(255,255,0);
          Lambda = 3000*Lambda;   
          index = (int)(Lambda);
          if(index>1023) index =1023;
          farbe = farben1024.farben1024FestBlau4[1023-index];   
      }else{  //Ordnung: bunt/Zufall - es werden keine Werte werden abgeschnitten
           Lambda = -500*Lambda;    //if(Lambda > 9000)print(Lambda+" ");      
           if(Lambda>8191) Lambda=8191;//Endfarbe des Verlaufs                        
           index =round((float)Lambda);
           farbe =  farben8192.farben8192[index];                 
      }
      if(undefiniert) farbe = color(0,255,255);//rot: Endfarbe
      break;
      
    case 5: 
       if(Lambda >= 0 ){  //Chaos: Differenzierung nach Größe des positiven Lambda    
          Lambda = 3000*Lambda;   
          index = (int)(Lambda);
          if(index>1023) index =1023;
          farbe = farben1024.farben1024Fest16Bunt[index];    
      }else{ //Ordnung: schwarz-weiß, linear gespreizt, seltene Lambda-Werte abgeschnitten    
          Lambda = -400*Lambda;             
          if(Lambda>255) Lambda=255; 
          index =(int)Lambda;                    
          farbe =  color(255-index);             
      }
      if(undefiniert) farbe = farben.farbenTrapRot1024[1023];     ; // Endfarbe farben[2048]
      break;
      
    case 6: //demokratische Grauwerte funktionieren erst, wenn zuvor einer der Fälle 1-5 gestartet wurde
         if(Lambda >= 0 ){ //Chaos:  schwarz -> blau linear
            Lambda = 3000*Lambda;   
            index = (int)(Lambda); //if(tN==4)print(index+" ");
            if(index>1023) index =1023; 
            farbe = farben1024.farben1024FestOrange4[1023-index];  
        }else{//Ordnung grau "demokratisch" - alle Lambda-Werte werden benutzt                    
           index = (int) (LNFaktor*Lambda);    
           gWert = gWertBestimmen256(index);  
           if(gWert>255) gWert =255;
           farbe =  color(255-gWert);             
      }   
      break;
    
    case 7: //demokratische Grauwerte funktionieren erst, wenn zuvor einer der Fälle 1-5 gestartet wurde
         if(Lambda >= 0 ){ //Chaos:  schwarz -> rot linear
            Lambda = 3000*Lambda;   
            index = (int)(Lambda); //if(tN==4)print(index+" ");
            if(index>1023) index =1023; 
            farbe = farben.farbenTrapRot1024[index];
        }else{//Ordnung Blautöne "demokratisch" - alle Lambda-Werte werden benutzt                    
           index = (int) (LNFaktor*Lambda);    
           gWert =(int) (gWertBestimmen1024(index));
           if(gWert>1023) gWert =1023;
           farbe =  farben1024.farben1024FestBlau4[1023-gWert];       
      }   
      break;
      
    }
    return farbe;  
 }
 //bestimmt den Grauwert256 zum Index/////////////////////////////////////////////////////////////////// 
 int gWertBestimmen256(int wert){
    int ergebnis =0;
    int n = (int)pow(2,7)-1;
    for(int i = 6; i>=0;i--){
      if( wert <= GrauBereich256[n]) n=n-(int)pow(2,i);
      else n=n+(int)pow(2,i);    
    }
    ergebnis =n; // if(tN==8)print(wert,ergebnis + "  ");   //hier ist bzgl 1 ein Fehler. Wird immer 254 zugeordnet
    return ergebnis;
 }
 //bestimme Grauwert1024 zum Index//////////////////////////////////////////////////////
 int gWertBestimmen1024(int wert){
    int ergebnis =0;
    int n = (int)pow(2,9)-1;
    for(int i = 8; i>=0;i--){
      if( wert <= GrauBereich1024[n]) n=n-(int)pow(2,i);
      else n=n+(int)pow(2,i);    
    }
    ergebnis =n; // if(tN==8)print(wert,ergebnis + "  ");   //hier ist bzgl 1 ein Fehler. Wird immer 254 zugeordnet
    return ergebnis;
 }
 
}
